# Pubnub Flutter
    
    Currently available for Android only.


<img src="https://www.pubnub.com/wp-content/uploads/2016/04/pubnub-share.png" width="300" height="200"> <img src="https://media.licdn.com/dms/image/C4D0BAQH109445BY2gA/company-logo_200_200/0?e=2159024400&v=beta&t=dbU_2Y_ULhxJ1a2Q3mBmCKNbgVeqPjcL_g5CKsmy4CY" width="300" height="200">


Pubnub plugin for Flutter apps built by [Deligence Technologies]("https://www.deligence.com/"). This plugin lets you integrate [Pubnub]("https://www.pubnub.com/") in your app.


### Minimum Requirements

> Android :  To use this plugin you must [`migrate to AndroidX`](`https://flutter.dev/docs/development/packages-and-plugins/androidx-compatibility`) and set your `minSdkVersion` to at least `20`.

## Methods to use

### To Initialize

```dart
 PubnubFlutter pubNubFlutter=PubnubFlutter();
// Getting random ID genetrated by android
String myId =await  pubNubFlutter.getUuidString();

//Initializing the plugin
pubNubFlutter=await pubNubFlutter.initialize(
           publishKey: "PUBLISH KEY",
           subscribeKey: "SUSBSCRIBE KEY",
           uuid: myId, // you can use any random Id 
           secretKey: "YOUR SECRET KEY");
```


### Listen to change in status or msg 

```dart
  pubNubFlutter.onStatusReceived.listen((status) {
         print("check your status $status ");
    });

  pubNubFlutter.onMessageReceived.listen((msg) {
         print("\n\n RECEIVED MESSAGE IS $msg \n\n");
    });
```

### Subscribe to channels

```dart
// return true || false based on result
bool sub = await pubNubFlutter.subscribe(channelNames:['test@234']);
```


### Publish msg to a channel

```dart
// Data should be of type Map<String,String>
data={"msg":"Something something something ...."};

// return true || false based on result
 bool msg=await pubNubFlutter.sendMessage(data: data, channel: channel);
```

### Unsubscribe to channels

```dart

// return true || false based on result
pubNubFlutter.unsubscribe();
```


### Note
> Currently this plugin is in development so their could be some breaking changes in next update.

> Unsubscribe to a single or multiple channel is yet not supported by this plugin.